<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: exampleEMGTracking.m</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('exampleEMGTracking_8m-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">exampleEMGTracking.m</div>  </div>
</div><!--header-->
<div class="contents">
<p>This is an example that uses the MocoInverse tool and EMG data to create an EMG-driven simulation of walking. This example is used in hands-on workshops, and accordingly has blanks that users must fill in. See <a class="el" href="exampleSquatToStand_answers_8m-example.html">exampleSquatToStand_answers.m</a> for a completed version.</p>
<div class="fragment"><div class="line"><span class="keyword">function</span> exampleEMGTracking</div>
<div class="line">clear; close all; clc;</div>
<div class="line"> </div>
<div class="line">%% Part 0: Load the <a class="code" href="namespaceOpenSim.html">OpenSim</a> and Moco libraries.</div>
<div class="line">import org.opensim.modeling.*;</div>
<div class="line"> </div>
<div class="line">%% Part 1: Muscle redundancy problem: effort minimization.</div>
<div class="line">% Solve the muscle redundancy problem <span class="keywordflow">while</span> minimizing muscle excitations</div>
<div class="line">% squared <span class="keyword">using</span> the MocoInverse tool. </div>
<div class="line"> </div>
<div class="line">% Part 1a: Load a 19 degree-of-freedom model with 18 lower-limb, </div>
<div class="line">% sagittal-plane muscles and a torque-actuated torso. This includes a set of </div>
<div class="line">% ground reaction forces applied to the model via ExternalLoads, which is </div>
<div class="line">% necessary for the muscle redundancy problem. See the function definition </div>
<div class="line">% at the bottom of this file to see how the model is loaded and constructed.</div>
<div class="line">model = getWalkingModel();  </div>
<div class="line"> </div>
<div class="line">% Part 1b: Create the MocoInverse tool and <span class="keyword">set</span> the Model.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Part 1c: Create a TableProcessor <span class="keyword">using</span> the coordinates file from inverse</div>
<div class="line">% kinematics.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Part 1d: Set the kinematics reference <span class="keywordflow">for</span> MocoInverse <span class="keyword">using</span> the </div>
<div class="line">% TableProcessor we just created.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Part 1e: Provide the solver settings: initial and <span class="keyword">final</span> time, the mesh </div>
<div class="line">% interval, and the constraint and convergence tolerances.</div>
<div class="line">inverse.set_initial_time( );</div>
<div class="line">inverse.set_final_time( );</div>
<div class="line">inverse.set_mesh_interval( );</div>
<div class="line">inverse.set_constraint_tolerance( );</div>
<div class="line">inverse.set_convergence_tolerance( );</div>
<div class="line"> </div>
<div class="line"><span class="keywordflow">if</span> ~exist(<span class="stringliteral">&#39;effortSolution.sto&#39;</span>, <span class="stringliteral">&#39;file&#39;</span>)</div>
<div class="line">    % Part 1f: Solve the problem!</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">%% Part 2: Plot the muscle redundancy problem solution.</div>
<div class="line">% Load the experimental electromyography data and compare </div>
<div class="line">% the effort minimization solution against <span class="keyword">this</span> data. We will also use</div>
<div class="line">% it later <span class="keywordflow">for</span> the EMG-tracking problem. Each column in emg.sto is </div>
<div class="line">% normalized so the maximum value for each signal is 1.0.</div>
<div class="line">emgReference = <a class="code" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a>(&#39;emg.sto&#39;);</div>
<div class="line">compareSolutionToEMG(emgReference, <span class="stringliteral">&#39;effortSolution.sto&#39;</span>);</div>
<div class="line"> </div>
<div class="line">%% Part 3: Muscle redundancy problem: EMG-tracking.</div>
<div class="line">% Modify the existing problem we created with the MocoInverse tool to solve</div>
<div class="line">% a new problem where we will track electromyography (EMG) data. </div>
<div class="line"> </div>
<div class="line">% Part 3a: Call initialize() to get access to the MocoStudy contained within</div>
<div class="line">% the MocoInverse instance. This will allow us to make additional</div>
<div class="line">% modifications to the problem not provided by MocoInverse.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Part 3b: Create a MocoControlTrackingGoal, set its weight, and provide</div>
<div class="line">% the EMG data as the tracking reference. We also need to specify the </div>
<div class="line">% reference labels for the four muscles whose EMG we will track.</div>
<div class="line">tracking = </div>
<div class="line">tracking.setWeight( );</div>
<div class="line">tracking.setReference( );</div>
<div class="line">tracking.setReferenceLabel(<span class="stringliteral">&#39;/forceset/gasmed_l&#39;</span>, <span class="stringliteral">&#39;gastrocnemius&#39;</span>);</div>
<div class="line">tracking.setReferenceLabel(<span class="stringliteral">&#39;/forceset/tibant_l&#39;</span>, <span class="stringliteral">&#39;tibialis_anterior&#39;</span>);</div>
<div class="line">tracking.setReferenceLabel(<span class="stringliteral">&#39;/forceset/bfsh_l&#39;</span>, <span class="stringliteral">&#39;biceps_femoris&#39;</span>);</div>
<div class="line">tracking.setReferenceLabel( );</div>
<div class="line"> </div>
<div class="line">% Part 3c: The EMG signals in the tracking are all normalized to have</div>
<div class="line">% a maximum value of 1, but the magnitudes of the excitations from the </div>
<div class="line">% effort minimization solution suggest that these signals should be</div>
<div class="line">% rescaled. Use addScaleFactor() to add a MocoParameter to the problem that</div>
<div class="line">% will scale the reference data for the muscles in the tracking cost.</div>
<div class="line">tracking.addScaleFactor(&#39;gastroc_factor&#39;, &#39;/forceset/gasmed_l&#39;, [0.01 1.0]); </div>
<div class="line">tracking.addScaleFactor(&#39;tibant_factor&#39;, &#39;/forceset/tibant_l&#39;, [0.01 1.0]); </div>
<div class="line">tracking.addScaleFactor(&#39;bifem_factor&#39;, &#39;/forceset/bfsh_l&#39;, [0.01 1.0]); </div>
<div class="line">tracking.addScaleFactor( ); </div>
<div class="line"> </div>
<div class="line">% Part 3d: Add the tracking goal to the problem.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Part 3e: Update the MocoCasADiSolver with the updated MocoProblem using </div>
<div class="line">% resetProblem().</div>
<div class="line">solver = MocoCasADiSolver.safeDownCast(study.updSolver());</div>
<div class="line">solver.resetProblem(problem);</div>
<div class="line"> </div>
<div class="line">% Part 3f: Tell MocoCasADiSolver that the MocoParameters we added to the </div>
<div class="line">% problem via addScaleFactor() above do not require initSystem() calls on</div>
<div class="line">% the model. This provides a large speed-up.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">if ~exist(&#39;trackingSolution.sto&#39;, &#39;file&#39;)</div>
<div class="line">    % Part 3g: Solve the problem!</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">% Part 3h: Get the values of the optimized scale factors.</div>
<div class="line">trackingSolution = MocoTrajectory(&#39;trackingSolution.sto&#39;);</div>
<div class="line">gastroc_factor = trackingSolution.getParameter(&#39;gastroc_factor&#39;);</div>
<div class="line">tibant_factor = trackingSolution.getParameter(&#39;tibant_factor&#39;);</div>
<div class="line">bifem_factor = trackingSolution.getParameter(&#39;bifem_factor&#39;);</div>
<div class="line">gluteus_factor = </div>
<div class="line"> </div>
<div class="line">%% Part 4: Plot the EMG-tracking muscle redundancy problem solution.</div>
<div class="line">% Part 4a: Print the scale factor values to the command window.</div>
<div class="line">fprintf(&#39;\n&#39;)</div>
<div class="line">fprintf(&#39;Optimized scale factor values: \n&#39;)</div>
<div class="line">fprintf(&#39;------------------------------ \n&#39;)</div>
<div class="line">fprintf([&#39;gastrocnemius = &#39; num2str(gastroc_factor) &#39;\n&#39;])</div>
<div class="line">fprintf([&#39;tibialis anterior = &#39; num2str(tibant_factor) &#39;\n&#39;])</div>
<div class="line">fprintf([&#39;biceps femoris <span class="keywordtype">short</span> head = &#39; num2str(bifem_factor) &#39;\n&#39;])</div>
<div class="line">fprintf([&#39;gluteus = &#39; num2str(gluteus_factor) &#39;\n&#39;])</div>
<div class="line">fprintf(&#39;\n&#39;)</div>
<div class="line"> </div>
<div class="line">% Part 4b: Re-scale the reference data using the optimized scale factors.</div>
<div class="line">gastroc = emgReference.updDependentColumn(&#39;gastrocnemius&#39;);</div>
<div class="line">tibant = emgReference.updDependentColumn(&#39;tibialis_anterior&#39;);</div>
<div class="line">bifem = emgReference.updDependentColumn(&#39;biceps_femoris&#39;);</div>
<div class="line">gluteus = emgReference.updDependentColumn(&#39;gluteus&#39;);</div>
<div class="line">for t = 0:emgReference.getNumRows() - 1</div>
<div class="line">    gastroc.set(t, gastroc_factor * gastroc.get(t));</div>
<div class="line">    tibant.set(t, tibant_factor * tibant.get(t));</div>
<div class="line">    bifem.set(t, bifem_factor * bifem.get(t));</div>
<div class="line">    gluteus.set(t, gluteus_factor * gluteus.get(t));</div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">% Part 4c: Generate the plots. Compare results to the effort minimization </div>
<div class="line">% solution.</div>
<div class="line">compareSolutionToEMG(emgReference, &#39;effortSolution.sto&#39;, ... </div>
<div class="line">    &#39;trackingSolution.sto&#39;);</div>
<div class="line"> </div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">% Add a CoordinateActuator to the provided model with a specified optimal</div>
<div class="line">% force. </div>
<div class="line">function addCoordinateActuator(model, coordinateName, optForce)</div>
<div class="line"> </div>
<div class="line">import org.opensim.modeling.*;</div>
<div class="line"> </div>
<div class="line">coordSet = model.getCoordinateSet();</div>
<div class="line"> </div>
<div class="line">actu = CoordinateActuator();</div>
<div class="line">actu.setName([&#39;torque_&#39; coordinateName]);</div>
<div class="line">actu.setCoordinate(coordSet.get(coordinateName));</div>
<div class="line">actu.setOptimalForce(optForce);</div>
<div class="line">actu.setMinControl(-1);</div>
<div class="line">actu.setMaxControl(1);</div>
<div class="line"> </div>
<div class="line">% Add to ForceSet</div>
<div class="line">model.addForce(actu);</div>
<div class="line"> </div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">function [modelProcessor] = getWalkingModel()</div>
<div class="line"> </div>
<div class="line">import org.opensim.modeling.*;</div>
<div class="line"> </div>
<div class="line">% Load the 19 DOF, 18 muscle model from file.</div>
<div class="line">model = Model(&#39;subject_walk_armless_18musc.osim&#39;);</div>
<div class="line"> </div>
<div class="line">% Add actuators representing the pelvis residual actuators and lumbar</div>
<div class="line">% torques. These actuators are only as strong as they need to be for the</div>
<div class="line">% problem to converge.</div>
<div class="line">addCoordinateActuator(model, &#39;pelvis_tx&#39;, 60)</div>
<div class="line">addCoordinateActuator(model, &#39;pelvis_ty&#39;, 300)</div>
<div class="line">addCoordinateActuator(model, &#39;pelvis_tz&#39;, 35)</div>
<div class="line">addCoordinateActuator(model, &#39;pelvis_tilt&#39;, 60)</div>
<div class="line">addCoordinateActuator(model, &#39;pelvis_list&#39;, 35)</div>
<div class="line">addCoordinateActuator(model, &#39;pelvis_rotation&#39;, 25)</div>
<div class="line">addCoordinateActuator(model, &#39;lumbar_bending&#39;, 40)</div>
<div class="line">addCoordinateActuator(model, &#39;lumbar_extension&#39;, 40)</div>
<div class="line">addCoordinateActuator(model, &#39;lumbar_rotation&#39;, 25)</div>
<div class="line"> </div>
<div class="line">% We need additional actuators for hip rotation and hip adduction since the</div>
<div class="line">% existing muscle act primarily in the sagittal plane.</div>
<div class="line">addCoordinateActuator(model, &#39;hip_rotation_r&#39;, 100)</div>
<div class="line">addCoordinateActuator(model, &#39;hip_rotation_l&#39;, 100)</div>
<div class="line">addCoordinateActuator(model, &#39;hip_adduction_r&#39;, 100)</div>
<div class="line">addCoordinateActuator(model, &#39;hip_adduction_l&#39;, 100)</div>
<div class="line"> </div>
<div class="line">% Create a ModelProcessor to make additional modifications to the model.</div>
<div class="line">modelProcessor = ModelProcessor(model);</div>
<div class="line">% Weld the subtalar and toe joints.</div>
<div class="line">jointsToWeld = StdVectorString();</div>
<div class="line">jointsToWeld.add(&#39;subtalar_r&#39;);</div>
<div class="line">jointsToWeld.add(&#39;subtalar_l&#39;);</div>
<div class="line">jointsToWeld.add(&#39;mtp_r&#39;);</div>
<div class="line">jointsToWeld.add(&#39;mtp_l&#39;);</div>
<div class="line">modelProcessor.append(ModOpReplaceJointsWithWelds(jointsToWeld));</div>
<div class="line">% Apply the ground reaction forces to the model.</div>
<div class="line">modelProcessor.append(ModOpAddExternalLoads(&#39;external_loads.xml&#39;));</div>
<div class="line">% Update the muscles: ignore tendon compliance and passive forces, replace </div>
<div class="line">% muscle types with the DeGrooteFregly2016Muscle type, and scale the width</div>
<div class="line">% of the active force length curve.</div>
<div class="line">modelProcessor.append(ModOpIgnoreTendonCompliance());</div>
<div class="line">modelProcessor.append(ModOpReplaceMusclesWithDeGrooteFregly2016());</div>
<div class="line">modelProcessor.append(ModOpIgnorePassiveFiberForcesDGF());</div>
<div class="line">modelProcessor.append(ModOpScaleActiveFiberForceCurveWidthDGF(1.5));</div>
<div class="line">% Add a set a weak reserves to the sagittal-plane joints in the model.</div>
<div class="line">modelProcessor.append(ModOpAddReserves(1.0));</div>
<div class="line"> </div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">function compareSolutionToEMG(varargin)</div>
<div class="line"> </div>
<div class="line">import org.opensim.modeling.*;</div>
<div class="line"> </div>
<div class="line">% Retrieve the inputs.</div>
<div class="line">emgReference = varargin{1};</div>
<div class="line">effortSolution = MocoTrajectory(varargin{2});</div>
<div class="line"><span class="keywordflow">if</span> nargin &gt; 2</div>
<div class="line">   trackingSolution = MocoTrajectory(varargin{3}); </div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">% Create a time vector <span class="keywordflow">for</span> the EMG data that is consistent with the problem</div>
<div class="line">% time range.</div>
<div class="line">time = effortSolution.getTimeMat();</div>
<div class="line">startIndex = emgReference.getNearestRowIndexForTime(time(1)) + 1;</div>
<div class="line">endIndex = emgReference.getNearestRowIndexForTime(time(end)) + 1;</div>
<div class="line">emgTime = linspace(time(1), time(end), endIndex - startIndex + 1);</div>
<div class="line"> </div>
<div class="line">% Plot results from the muscles in the left leg. </div>
<div class="line">titles = {<span class="stringliteral">&#39;soleus&#39;</span>, <span class="stringliteral">&#39;gastroc.&#39;</span>, <span class="stringliteral">&#39;tib. ant.&#39;</span>, <span class="stringliteral">&#39;hamstrings&#39;</span>, ...</div>
<div class="line">          <span class="stringliteral">&#39;bi. fem. sh.&#39;</span>, <span class="stringliteral">&#39;vastus&#39;</span>, <span class="stringliteral">&#39;rec. fem.&#39;</span>, <span class="stringliteral">&#39;gluteus&#39;</span>, <span class="stringliteral">&#39;psoas&#39;</span>};</div>
<div class="line">emgSignals = {<span class="stringliteral">&#39;soleus&#39;</span>, <span class="stringliteral">&#39;gastrocnemius&#39;</span>, <span class="stringliteral">&#39;tibialis_anterior&#39;</span>, ... </div>
<div class="line">              <span class="stringliteral">&#39;hamstrings&#39;</span>, <span class="stringliteral">&#39;biceps_femoris&#39;</span>, <span class="stringliteral">&#39;vastus&#39;</span>, ...</div>
<div class="line">              <span class="stringliteral">&#39;rectus_femoris&#39;</span>, <span class="stringliteral">&#39;gluteus&#39;</span>, <span class="stringliteral">&#39;none&#39;</span>};</div>
<div class="line">muscles = {<span class="stringliteral">&#39;soleus_l&#39;</span>, <span class="stringliteral">&#39;gasmed_l&#39;</span>, <span class="stringliteral">&#39;tibant_l&#39;</span>, <span class="stringliteral">&#39;semimem_l&#39;</span>, <span class="stringliteral">&#39;bfsh_l&#39;</span>, ...</div>
<div class="line">           <span class="stringliteral">&#39;vasint_l&#39;</span>, <span class="stringliteral">&#39;recfem_l&#39;</span>, <span class="stringliteral">&#39;glmax2_l&#39;</span>, <span class="stringliteral">&#39;psoas_l&#39;</span>};     </div>
<div class="line">figure;</div>
<div class="line"><span class="keywordflow">for</span> i = 1:length(titles)</div>
<div class="line">    subplot(3,3,i)</div>
<div class="line">    </div>
<div class="line">    % If it exists, plot the EMG signal <span class="keywordflow">for</span> <span class="keyword">this</span> muscle.</div>
<div class="line">    <span class="keywordflow">if</span> ~strcmp(emgSignals{i}, <span class="stringliteral">&#39;none&#39;</span>)</div>
<div class="line">        col = emgReference.getDependentColumn(emgSignals{i}).getAsMat();</div>
<div class="line">        emg = col(startIndex:endIndex)<span class="stringliteral">&#39;;</span></div>
<div class="line"><span class="stringliteral">        patch([emgTime fliplr(emgTime)], [emg fliplr(zeros(size(emg)))], ...</span></div>
<div class="line"><span class="stringliteral">            [0.7 0.7 0.7])</span></div>
<div class="line"><span class="stringliteral">        alpha(0.5);</span></div>
<div class="line"><span class="stringliteral">    end</span></div>
<div class="line"><span class="stringliteral">    hold on</span></div>
<div class="line"><span class="stringliteral">    </span></div>
<div class="line"><span class="stringliteral">    % Plot the control from the muscle effort solution.</span></div>
<div class="line"><span class="stringliteral">    control = effortSolution.getControlMat([&#39;</span>/forceset/<span class="stringliteral">&#39; muscles{i}]);</span></div>
<div class="line"><span class="stringliteral">    plot(time, control, &#39;</span>-k&#39;, &#39;linewidth&#39;, 2)</div>
<div class="line">    </div>
<div class="line">    % If provided, plot the control from the tracking solution.</div>
<div class="line">    if nargin &gt; 2</div>
<div class="line">        control = trackingSolution.getControlMat([&#39;/forceset/&#39; muscles{i}]);</div>
<div class="line">        plot(time, control, <span class="stringliteral">&#39;-r&#39;</span>, <span class="stringliteral">&#39;linewidth&#39;</span>, 2)</div>
<div class="line">    end</div>
<div class="line">    </div>
<div class="line">    % Plot formatting.</div>
<div class="line">    title(titles{i})</div>
<div class="line">    xlim([0.83 2.0])</div>
<div class="line">    ylim([0 1])</div>
<div class="line">    if i == 1</div>
<div class="line">        if nargin &gt; 2</div>
<div class="line">            legend(&#39;EMG&#39;, &#39;effort&#39;, &#39;tracking&#39;, &#39;location&#39;, &#39;best&#39;)</div>
<div class="line">        else</div>
<div class="line">            legend(&#39;EMG&#39;, &#39;effort&#39;, &#39;location&#39;, &#39;best&#39;)</div>
<div class="line">        end</div>
<div class="line">    end</div>
<div class="line">    if i &gt; 6</div>
<div class="line">        xlabel(&#39;time (s)&#39;)</div>
<div class="line">    else</div>
<div class="line">        xticklabels([])</div>
<div class="line">    end</div>
<div class="line">    if ~mod(i-1, 3)</div>
<div class="line">        ylabel(&#39;excitation&#39;)</div>
<div class="line">    else</div>
<div class="line">        yticklabels([])</div>
<div class="line">    end</div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">end</div>
<div class="ttc" id="anamespaceOpenSim_html"><div class="ttname"><a href="namespaceOpenSim.html">OpenSim</a></div><div class="ttdoc">The Moco interface is contained within the OpenSim namespace.</div><div class="ttdef"><b>Definition:</b> ActivationCoordinateActuator.h:30</div></div>
<div class="ttc" id="anamespaceOpenSim_html_a39e2414750443cfa41c224f5cdd31bac"><div class="ttname"><a href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">OpenSim::TimeSeriesTable</a></div><div class="ttdeci">TimeSeriesTable_&lt; SimTK::Real &gt; TimeSeriesTable</div><div class="ttdoc">See TimeSeriesTable_ for details on the interface.</div><div class="ttdef"><b>Definition:</b> TimeSeriesTable.h:519</div></div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:01 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
